# strings.cpp File Reference

`#include "stdafx.h"`
`#include "openttd.h"`
`#include "currency.h"`
`#include "namegen.h"`
`#include "station.h"`
`#include "town.h"`
`#include "news.h"`
`#include "screenshot.h"`
`#include "waypoint.h"`
`#include "industry.h"`
`#include "variables.h"`
`#include "newgrf_text.h"`
`#include "music.h"`
`#include "fileio.h"`
`#include "cargotype.h"`
`#include "group.h"`
`#include "debug.h"`
`#include "newgrf_townname.h"`
`#include "signs.h"`
`#include "newgrf_engine.h"`
`#include "spritecache.h"`
`#include "fontcache.h"`
`#include "gui.h"`
`#include "strings_func.h"`
`#include "functions.h"`
`#include "core/endian_func.hpp"`
`#include "date_func.h"`
`#include "vehicle_base.h"`
`#include "string_func.h"`
`#include "player_func.h"`
`#include "player_base.h"`
`#include "fios.h"`
`#include "settings_type.h"`
`#include "video/video_driver.hpp"`
`#include "table/strings.h"`
`#include "table/control_codes.h"`

Go to the source code of this file.

## Data Structures
struct | LanguagePack
struct | Units
## Defines
#define | NUM_BOUND_STRINGS 8
## Functions
static char * | StationGetSpecialString (char *buff, int x, const char *last)
static char * | GetSpecialTownNameString (char *buff, int ind, uint32 seed, const char *last)
static char * | GetSpecialPlayerNameString (char *buff, int ind, const int64 *argv, const char *last)
static char * | FormatString (char *buff, const char *str, const int64 *argv, uint casei, const char *last)
static int64 | GetInt64 (const int64 **argv)
| Read an int64 from the argv array.
static int32 | GetInt32 (const int64 **argv)
| Read an int32 from the argv array.
static const int64 * | GetArgvPtr (const int64 **argv, int n)
| Read an array from the argv array.
const char * | GetStringPtr (StringID string)
static char * | GetStringWithArgs (char *buffr, uint string, const int64 *argv, const char *last)
| The highest 8 bits of string contain the "case index".
char * | GetString (char *buffr, StringID string, const char *last)
char * | InlineString (char *buf, StringID string)
StringID | BindCString (const char *str)
| This function takes a C-string and allocates a temporary string ID.
void | SetDParamStr (uint n, const char *str)
| This function is used to "bind" a C string to a OpenTTD dparam slot.
void | InjectDParam (int amount)
static char * | FormatCommaNumber (char *buff, int64 number, const char *last)
static char * | FormatNoCommaNumber (char *buff, int64 number, const char *last)
static char * | FormatYmdString (char *buff, Date date, const char *last)
static char * | FormatMonthAndYear (char *buff, Date date, const char *last)
static char * | FormatTinyDate (char *buff, Date date, const char *last)
static char * | FormatGenericCurrency (char *buff, const CurrencySpec *spec, Money number, bool compact, const char *last)
static int | DeterminePluralForm (int64 cnt)
static const char * | ParseStringChoice (const char *b, uint form, char *dst, int *dstlen)
static char * | GenAndCoName (char *buff, uint32 arg, const char *last)
static char * | GenPresidentName (char *buff, uint32 x, const char *last)
StringID | RemapOldStringID (StringID s)
| remap a string ID from the old format to the new format
static void | SortNetworkLanguages ()
bool | ReadLanguagePack (int lang_index)
const char * | GetCurrentLocale (const char *param)
| Determine the current charset based on the environment First check some default values, after this one we passed ourselves and if none exist return the value for $LANG.
int CDECL | StringIDSorter (const void *a, const void *b)
static bool | UniqueLanguageFile (const Language *langs, uint max, const char *language)
| Checks whether the given language is already found.
static bool | GetLanguageFileHeader (const char *file, LanguagePack *hdr)
| Reads the language file header and checks compatability.
static int | GetLanguageList (Language *langs, int start, int max, const char *path)
| Gets a list of languages from the given directory.
void | InitializeLanguagePacks ()
| Make a list of the available language packs.
void | CheckForMissingGlyphsInLoadedLanguagePack ()
| Check whether the currently loaded language pack uses characters that the currently loaded font does not support.
## Variables
DynamicLanguages | _dynlang
char | _userstring [128]
uint64 | _decode_parameters [20]
static char ** | _langpack_offs
static LanguagePack * | _langpack
static uint | _langtab_num [32]
static uint | _langtab_start [32]
static const char * | _bound_strings [NUM_BOUND_STRINGS]
static int | _bind_index
static const Units | units []
static const char *const | _silly_company_names []
static const char *const | _surname_list []
static const char *const | _silly_surname_list []
static const char | _initial_name_letters []

## Detailed Description

Definition in file strings.cpp.

## Function Documentation

StringID BindCString | ( | const char * | str | ) |

This function takes a C-string and allocates a temporary string ID.

The StringID of the bound string is valid until BindCString is called another NUM_BOUND_STRINGS times. So be careful when using it.

Parameters:

  | str | temp string to add

Returns:
  the id of that temp string

Note:
  formatting a DATE_TINY calls BindCString twice, thus reduces the amount of 'user' bound strings by 2.

Todo:
  rewrite the BindCString system to make the limit flexible and non-round-robin. For example by using smart pointers that free the allocated StringID when they go out-of-scope/are freed.

Definition at line 212 of file strings.cpp.

Referenced by CheckForMissingGlyphsInLoadedLanguagePack(), and SetDParamStr().

void CheckForMissingGlyphsInLoadedLanguagePack | ( |  | ) |

Check whether the currently loaded language pack uses characters that the currently loaded font does not support.

If this is the case an error message will be shown in English. The error message will not be localized because that would mean it might use characters that are not in the font, which is the whole reason this check has been added.

Definition at line 1494 of file strings.cpp.

References BindCString().

static const int64* GetArgvPtr | ( | const int64 ** | argv,
|  | int | n |
| ) |  |  | `[inline, static]`

Read an array from the argv array.

Definition at line 86 of file strings.cpp.

const char* GetCurrentLocale | ( | const char * | param | ) |

Determine the current charset based on the environment First check some default values, after this one we passed ourselves and if none exist return the value for $LANG.

Parameters:

  | param | environment variable to check conditionally if default ones are not set. Pass NULL if you don't want additional checks.

Returns:
  return string containing current charset, or NULL if not-determinable

Definition at line 1314 of file strings.cpp.

static int32 GetInt32 | ( | const int64 ** | argv | ) | `[inline, static]`

Read an int32 from the argv array.

Definition at line 80 of file strings.cpp.

References GetInt64().

Referenced by GetStringWithArgs().

static int64 GetInt64 | ( | const int64 ** | argv | ) | `[inline, static]`

Read an int64 from the argv array.

Definition at line 73 of file strings.cpp.

Referenced by GetInt32().

static bool GetLanguageFileHeader | ( | const char * | file,
|  | LanguagePack * | hdr |
| ) |  |  | `[static]`

Reads the language file header and checks compatability.

Parameters:

  | file | the file to read
  | hdr | the place to write the header information to

Returns:
  true if and only if the language file is of a compatible version

Definition at line 1368 of file strings.cpp.

Referenced by GetLanguageList(), and InitializeLanguagePacks().

static int GetLanguageList | ( | Language * | langs,
|  | int | start,
|  | int | max,
|  | const char * | path |
| ) |  |  | `[static]`

Gets a list of languages from the given directory.

Parameters:

  | langs | the list to write to
  | start | the initial offset in the list
  | max | the length of the language list
  | path | the base directory to search in

Returns:
  the number of added languages

Definition at line 1389 of file strings.cpp.

References Language::file, FS2OTTD(), GetLanguageFileHeader(), ttd_opendir(), and UniqueLanguageFile().

Referenced by InitializeLanguagePacks().

static char* GetStringWithArgs | ( | char * | buffr,
|  | uint | string,
|  | const int64 * | argv,
|  | const char * | last |
| ) |  |  | `[static]`

The highest 8 bits of string contain the "case index".

These 8 bits will only be set when FormatString wants to print the string in a different case. No one else except FormatString should set those bits, therefore string CANNOT be StringID, but uint32.

Parameters:

  | buffr |
  | string |
  | argv |
  | last |

Returns:
  a formatted string of char

Definition at line 127 of file strings.cpp.

References error, GB(), GetGRFStringID(), GetInt32(), and HasBit().

void InitializeLanguagePacks | ( |  | ) |

Make a list of the available language packs.

put the data in _dynlang struct.

< Matching the language in the configuartion file or the current locale

< Using pt_PT for pt_BR locale when pt_BR is not available

< Fallback when no locale-matching language has been found

Definition at line 1426 of file strings.cpp.

References DynamicLanguages::curr_file, DynamicLanguages::ent, error, Language::file, FOR_ALL_SEARCHPATHS, GetCurrentLocale(), GetLanguageFileHeader(), GetLanguageList(), LANG_DIR, Language::name, and DynamicLanguages::num.

StringID RemapOldStringID | ( | StringID | s | ) |

remap a string ID from the old format to the new format

Parameters:

  | s | StringID that requires remapping

Returns:
  translated ID

Definition at line 1219 of file strings.cpp.

References IsInsideMM().

Referenced by SlSaveLoadConv().

void SetDParamStr | ( | uint | n,
|  | const char * | str |
| ) |  |  |

This function is used to "bind" a C string to a OpenTTD dparam slot.

Parameters:

  | n | slot of the string
  | str | string to bind

Definition at line 223 of file strings.cpp.

References BindCString().

Referenced by GetSaveLoadErrorString(), RailVehicleLengthChanged(), SaveFileError(), and StartScenario().

static bool UniqueLanguageFile | ( | const Language * | langs,
|  | uint | max,
|  | const char * | language |
| ) |  |  | `[static]`

Checks whether the given language is already found.

Parameters:

  | langs | languages we've found so fa
  | max | the length of the language list
  | language | name of the language to check

Returns:
  true if and only if a language file with the same name has not been found

Definition at line 1352 of file strings.cpp.

Referenced by GetLanguageList().

## Variable Documentation

const char _initial_name_letters[]`[static]`

Initial value:

     {
      'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J',
      'K', 'L', 'M', 'N', 'P', 'R', 'S', 'T', 'W',
    }

Definition at line 1114 of file strings.cpp.

const char* const _silly_company_names[]`[static]`

Initial value:

     {
      "Bloggs Brothers",
      "Tiny Transport Ltd.",
      "Express Travel",
      "Comfy-Coach & Co.",
      "Crush & Bump Ltd.",
      "Broken & Late Ltd.",
      "Sam Speedy & Son",
      "Supersonic Travel",
      "Mike's Motors",
      "Lightning International",
      "Pannik & Loozit Ltd.",
      "Inter-City Transport",
      "Getout & Pushit Ltd."
    }

Definition at line 1051 of file strings.cpp.

const char* const _silly_surname_list[]`[static]`

Initial value:

     {
      "Grumpy",
      "Dozy",
      "Speedy",
      "Nosey",
      "Dribble",
      "Mushroom",
      "Cabbage",
      "Sniffle",
      "Fishy",
      "Swindle",
      "Sneaky",
      "Nutkins"
    }

Definition at line 1099 of file strings.cpp.

const Units units[]`[static]`

Initial value:

     {
      {
           1,  0, STR_UNITS_VELOCITY_IMPERIAL,
           1,  0, STR_UNITS_POWER_IMPERIAL,
           1,  0, STR_UNITS_WEIGHT_SHORT_METRIC, STR_UNITS_WEIGHT_LONG_METRIC,
        1000,  0, STR_UNITS_VOLUME_SHORT_METRIC, STR_UNITS_VOLUME_LONG_METRIC,
           1,  0, STR_UNITS_FORCE_SI,
      },
      {
         103,  6, STR_UNITS_VELOCITY_METRIC,
           1,  0, STR_UNITS_POWER_METRIC,
           1,  0, STR_UNITS_WEIGHT_SHORT_METRIC, STR_UNITS_WEIGHT_LONG_METRIC,
        1000,  0, STR_UNITS_VOLUME_SHORT_METRIC, STR_UNITS_VOLUME_LONG_METRIC,
           1,  0, STR_UNITS_FORCE_SI,
      },
      {
        1831, 12, STR_UNITS_VELOCITY_SI,
         764, 10, STR_UNITS_POWER_SI,
        1000,  0, STR_UNITS_WEIGHT_SHORT_SI, STR_UNITS_WEIGHT_LONG_SI,
           1,  0, STR_UNITS_VOLUME_SHORT_SI, STR_UNITS_VOLUME_LONG_SI,
           1,  0, STR_UNITS_FORCE_SI,
      },
    }

Definition at line 514 of file strings.cpp.